static inline unsigned make_prime__bound(unsigned nr)
{
	unsigned long long nr64 = nr;
	unsigned long long x = 1;
	nr = 1;
	while (x <= nr64) { x <<= 2; nr <<= 1; }
	return nr;
}

static inline int make_prime__check(unsigned nr)
{
	unsigned x = 3;
	unsigned b = make_prime__bound(nr);
	while (x <= b) {
		if (0 == (nr % x)) return 0;
		x += 2;
	}
	return 1;
}

static unsigned make_prime(unsigned nr)
{
	if (0 == (nr & 1)) nr--;
	while (nr > 1) {
		if (make_prime__check(nr)) return nr;
		nr -= 2;
	}
	return 2;
}

#ifdef MAKE_PRIME_MAIN
int main(int argc, char **argv)
{
	unsigned last_res = 0;
	while (--argc > 0) {
		unsigned res = make_prime(strtoul(*++argv, 0, 10));
		if (res != last_res) {
			printf("%u\n", res);
			last_res = res;
		}
	}
	return 0;
}
#endif
